import Fuse, { FuseResult } from 'fuse.js';
import * as React from 'react';
import { FinalResults } from './formatResults';
declare class FuzzyHighlighter<T, O> extends React.Component<IFuzzyHighlighterProps<T, O>, IFuzzyHighlighterState<T>> {
    readonly state: IFuzzyHighlighterState<T>;
    private fuse;
    componentDidMount(): void;
    componentDidUpdate(prevProps: IFuzzyHighlighterProps<T, O>): void;
    render(): {} | null | undefined;
    search(): void;
}
declare type Data<T> = ReadonlyArray<T>;
declare type Options<O> = Fuse.FuseOptions<Readonly<O>>;
interface IFuzzyHighlighterProps<T, O> {
    query: string;
    data: Data<T>;
    options?: Options<O>;
    children?: (params: {
        results: ReadonlyArray<FuseResult<T>>;
        formattedResults: FinalResults<T>;
        timing: number;
    }) => React.ReactNode;
}
export declare type Result<T> = FuseResult<T>;
export declare type Results<T> = ReadonlyArray<Result<T>>;
interface IFuzzyHighlighterState<T> {
    results: Results<T>;
    cache: {
        [query: string]: ReadonlyArray<FuseResult<T>>;
    };
    info: {
        timing: number;
    };
}
export default FuzzyHighlighter;
